"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.TelerikReportViewer = void 0;
require("../dependencies/initExtDeps");
var _react = _interopRequireDefault(require("react"));
var _telerikReportViewer = require("../dependencies/telerikReportViewer.js");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
class TelerikReportViewer extends _react.default.Component {
  constructor() {
    super();
    this.state = {
      reportViewerID: ''
    };
  }
  componentDidMount() {
    this.setState({
      reportViewerID: this.props.id || "reportViewer1"
    });
    const keepClientAlive = this.props.keepClientAlive === undefined ? true : this.props.keepClientAlive;
    this.viewerObject = new _telerikReportViewer.ReportViewer(this.el, {
      id: this.state.reportViewerID,
      serviceUrl: this.props.serviceUrl,
      reportServer: this.props.reportServer,
      trvTemplateUrl: this.props.templateUrl,
      initialPageAreaImageUrl: this.props.initialPageAreaImageUrl,
      reportSource: this.props.reportSource,
      sendEmail: this.props.sendEmail,
      scale: this.props.scale,
      scaleMode: this.props.scaleMode,
      viewMode: this.props.viewMode,
      pageMode: this.props.pageMode,
      parameters: this.props.parameters,
      persistSession: this.props.persistSession,
      parameterEditors: this.props.parameterEditors,
      authenticationToken: this.props.authenticationToken,
      ready: this.props.ready,
      printMode: this.props.printMode,
      selector: this.props.selector,
      disabledButtonClass: this.props.disabledButtonClass,
      checkedButtonClass: this.props.checkedButtonClass,
      exportBegin: this.props.exportBegin,
      exportEnd: this.props.exportEnd,
      printBegin: this.props.printBegin,
      printEnd: this.props.printEnd,
      renderingBegin: this.props.renderingBegin,
      renderingEnd: this.props.renderingEnd,
      sendEmailBegin: this.props.sendEmailBegin,
      sendEmailEnd: this.props.sendEmailEnd,
      updateUi: this.props.updateUi,
      pageReady: this.props.pageReady,
      error: this.props.error,
      interactiveActionExecuting: this.props.interactiveActionExecuting,
      interactiveActionEnter: this.props.interactiveActionEnter,
      interactiveActionLeave: this.props.interactiveActionLeave,
      viewerToolTipOpening: this.props.viewerToolTipOpening,
      enableAccessibility: this.props.enableAccessibility,
      searchMetadataOnDemand: this.props.searchMetadataOnDemand,
      parametersAreaVisible: this.props.parametersAreaVisible,
      documentMapVisible: this.props.documentMapVisible,
      documentMapAreaPosition: this.props.documentMapAreaPosition,
      parametersAreaPosition: this.props.parametersAreaPosition,
      keepClientAlive: keepClientAlive
    });
    this.commands = this.viewerObject.commands;
  }
  componentWillUnmount() {
    this.dispose();
  }
  render() {
    return /*#__PURE__*/_react.default.createElement("div", {
      id: this.state.reportViewerID,
      style: {
        ...this.props.viewerContainerStyle
      },
      ref: el => this.el = el
    });
  }
  refreshReport() {
    return this.viewerObject.refreshReport();
  }
  getReportSource() {
    return this.viewerObject.reportSource();
  }
  setReportSource(rs) {
    return this.viewerObject.reportSource(rs);
  }
  getViewMode() {
    return this.viewerObject.viewMode();
  }
  setViewMode(vm) {
    return this.viewerObject.viewMode(vm);
  }
  getScale() {
    return this.viewerObject.scale();
  }
  setScale(scale) {
    return this.viewerObject.scale(scale);
  }
  pageCount() {
    return this.viewerObject.pageCount();
  }
  currentPage() {
    return this.viewerObject.currentPage();
  }
  setAuthenticationToken(token) {
    return this.viewerObject.authenticationToken(token);
  }
  getAccessibilityKeyMap() {
    return this.viewerObject.accessibilityKeyMap();
  }
  setAccessibilityKeyMap(keyMap) {
    return this.viewerObject.accessibilityKeyMap(keyMap);
  }
  bind(eventName, eventHandler) {
    this.viewerObject.bind(eventName, eventHandler);
  }
  unbind(eventName, eventHandler) {
    this.viewerObject.unbind(eventName, eventHandler);
  }
  unbindAll(eventName) {
    this.viewerObject.unbind(eventName);
  }
  getPageMode() {
    return this.viewerObject.pageMode();
  }
  setPageMode(psm) {
    return this.viewerObject.pageMode(psm);
  }
  clearReportSource() {
    return this.viewerObject.clearReportSource();
  }
  dispose() {
    return this.viewerObject.dispose();
  }
  getReportParameters() {
    return this.viewerObject.getReportParameters();
  }
}
exports.TelerikReportViewer = TelerikReportViewer;
var _default = exports.default = TelerikReportViewer;